package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallPromotionRuleApplicationService;
import com.jeesharp.business.modules.mall.dto.MallPromotionRuleSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallPromotionRuleInfoVO;
import com.jeesharp.business.modules.mall.vo.MallPromotionRuleListVO;
import com.jeesharp.business.modules.mall.vo.MallPromotionRuleQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 满减/满赠规则管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/promotionRule/v1")
@Tag(name = "满减/满赠规则管理")
@AllArgsConstructor
public class MallPromotionRuleController extends BaseController {

    private final MallPromotionRuleApplicationService mallPromotionRuleApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallPromotionRuleInfoVO> info(@RequestParam("id") String id) {
        MallPromotionRuleInfoVO vo = mallPromotionRuleApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallPromotionRuleListVO>> list(@RequestBody MallPromotionRuleQueryVO query) {
        PageRespVO<MallPromotionRuleListVO> page = mallPromotionRuleApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallPromotionRuleSaveDTO dto) {
        mallPromotionRuleApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallPromotionRuleApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
